local Tunnel = module('vrp', 'lib/Tunnel')
local Proxy = module('vrp', 'lib/Proxy')

vRP = Proxy.getInterface('vRP')
vRPclient = Tunnel.getInterface("vRP","vrp_bus")
vRPCbus = Tunnel.getInterface("vrp_bus","vrp_bus")

vRPSbus = {}
Tunnel.bindInterface("vrp_bus",vRPSbus)
Proxy.addInterface("vrp_bus",vRPSbus)

local loadautobuz = [[
busSpawnLocs = nil
busStopsLocs = nil
theBlips = {}
busStopsBlip = nil
theBus = nil
hasBusRouteStarted = false
busCheckpoint = 0
atBusStop = false
finishBusRoute = {}
finishBlip = nil
busBlip = nil
busStopsBlip2 = nil
ReplaceHudColourWithRgba(141, 114, 243)
local fontsLoaded = false
local font
AddEventHandler("playerSpawned",function()
Citizen.CreateThread(function()
	Citizen.Wait(1000)
		RegisterFontFile('wmk')
		font = RegisterFontId('Freedom Font')
		fontsLoaded = true
	end)
end)

function vRPCbus.busPopulateData(busSpawns, busLocs, finishTrash)
	busSpawnLocs = busSpawns
	busStopsLocs = busLocs
	finishBusRoute = finishTrash
end

function vRPCbus.deleteTheBus()
	if(DoesEntityExist(theBus))then
		Citizen.InvokeNative(0xEA386986E786A54F, Citizen.PointerValueIntInitialized(theBus))
		theBus = nil
	end
end

function vRPCbus.spawnTheBus()
	if(theBus == nil)then
		coords = GetEntityCoords(PlayerPedId(), true)
		vehicle = GetHashKey("coach")
		RequestModel(vehicle)
		while not HasModelLoaded(vehicle) do
			Citizen.Wait(0)
		end
		theBus = CreateVehicle(vehicle, coords.x, coords.y, coords.z, 88.0, true, false)
		SetVehicleOnGroundProperly(theBus)
		SetEntityInvincible(theBus, false)
		SetPedIntoVehicle(PlayerPedId(), theBus, -1)
		Citizen.InvokeNative(0xAD738C3085FE7E11, theBus, true, true) -- set as mission entity
		SetVehicleHasBeenOwnedByPlayer(theBus, true)
		SetModelAsNoLongerNeeded(vehicle)
	end
end

function vRPCbus.startBusRoute()
	hasBusRouteStarted = true
	for i, v in pairs(theBlips) do
		if(DoesBlipExist(v))then
			RemoveBlip(v)
			theBlips[i] = nil
		end
	end
	vRPCbus.nextBusStop()
	vRP.notify({"Succes: Ai pornit la drum, ai grija cum conduci!"})
end

function vRPCbus.nextBusStop()
	busCheckpoint = busCheckpoint + 1
	if(busStopsLocs[busCheckpoint][4] == true)then
		blipColor = 1
	else
		blipColor = 1
	end
	if(busStopsBlip == nil) or (DoesBlipExist(busStopsBlip))then
		if(DoesBlipExist(busStopsBlip))then
			RemoveBlip(busStopsBlip)
		end
		busStopsBlip = AddBlipForCoord(busStopsLocs[busCheckpoint][1], busStopsLocs[busCheckpoint][2], busStopsLocs[busCheckpoint][3])
		SetBlipRoute(busStopsBlip, true)
		SetBlipSprite(busStopsBlip, 270)
		SetBlipColour(busStopsBlip, blipColor)
		SetBlipRouteColour(busStopsBlip, 1)
	end
	if(busCheckpoint+1 <= #busStopsLocs)then
		if(busStopsBlip2 == nil) or (DoesBlipExist(busStopsBlip2))then
			if(DoesBlipExist(busStopsBlip2))then
				RemoveBlip(busStopsBlip2)
			end
			busStopsBlip2 = AddBlipForCoord(busStopsLocs[busCheckpoint+1][1], busStopsLocs[busCheckpoint+1][2], busStopsLocs[busCheckpoint+1][3])
			SetBlipSprite(busStopsBlip2, 270)
			SetBlipColour(busStopsBlip2, 1)
		end
	end
end

function vRPCbus.stopBusRoute()
	hasBusRouteStarted = false
	vRP.notify({"Succes: Ai anulat tura de Sofer Autobuz!"})
	busCheckpoint = 0
	if(DoesBlipExist(busStopsBlip))then
		RemoveBlip(busStopsBlip)
		busStopsBlip = nil
	end
	if(DoesBlipExist(busStopsBlip2))then
		RemoveBlip(busStopsBlip2)
		busStopsBlip2 = nil
	end
	if(DoesBlipExist(busBlip))then
		RemoveBlip(busBlip)
		busBlip = nil
	end
	if(DoesBlipExist(finishBlip))then
		RemoveBlip(finishBlip)
		finishBlip = nil
	end
	vRPSbus.stopBusRoute({})
	atBusStop = false
end

function vRPCbus.finishBusRoute(route)
	hasBusRouteStarted = false
	busCheckpoint = 0
	if(DoesBlipExist(busStopsBlip))then
		RemoveBlip(busStopsBlip)
		busStopsBlip = nil
	end
	if(DoesBlipExist(busStopsBlip2))then
		RemoveBlip(busStopsBlip2)
		busStopsBlip2 = nil
	end
	if(DoesBlipExist(busBlip))then
		RemoveBlip(busBlip)
		busBlip = nil
	end
	if(DoesBlipExist(finishBlip))then
		RemoveBlip(finishBlip)
		finishBlip = nil
	end
	atBusStop = false
	vRPCbus.deleteTheBus()
	vRPSbus.payBusDriverZA({route})
end

function vRPCbus.stopAtBusStop(isBusStop)
	if(isBusStop == false)then
		vRPCbus.nextBusStop()
	else
		if(atBusStop == false)then
			atBusStop = true
			vRP.notify({"Info: ~w~Asteapta la statie pana ce ~y~pasagerii ~w~au urcat!"})
			SetTimeout(8000, function()
				if(atBusStop)then
					atBusStop = false
					if(#busStopsLocs > busCheckpoint)then
						vRPCbus.nextBusStop()
						vRP.notify({"Succes: ~y~Pasagerii au urcat!\n~w~Te poti duce la urmatoarea statie"})
						vRPSbus.oferaCash({})
					else
						if(DoesBlipExist(busStopsBlip))then
							RemoveBlip(busStopsBlip)
							busStopsBlip = nil
						end
						vRP.notify({"Succes: ~y~Ti-ai terminat misiunea!\n~w~Intoarce-te inapoi la depou pentru a lasa autobuzul!"})
					end
				else
					vRP.notify({"Eroare: ~y~Trebuie sa astepti in checkpoint pentru a lasa pasagerii sa urce!"})
				end
			end)
		end
	end
end

Citizen.CreateThread(function()
	while true do
		Wait(0)
		local ped = PlayerPedId()	
		local pos = GetEntityCoords(ped, true)	
		if((not DoesEntityExist(theBus)) or (IsEntityDead(theBus))) and (hasBusRouteStarted)then
			vRPCbus.stopBusRoute()
			theBus = nil
		end
		if(atBusStop)then
			drawText("~g~Asteapta in statie pana urca toti pasagerii", 0.5, 0.9, 0.4, 255, 255, 255)
		end
		if(theBus ~= nil)then
			if(GetVehiclePedIsIn(ped, false) == theBus) and (GetPedInVehicleSeat(theBus, -1) == ped) then
				if(hasBusRouteStarted == false)then
					vRPCbus.startBusRoute()
				end
				if(tonumber(#busStopsLocs) > tonumber(busCheckpoint))then
					if(#busStopsLocs >= busCheckpoint+1)then
						if(busStopsLocs[busCheckpoint+1][4] == true)then
							DrawMarker(1, busStopsLocs[busCheckpoint+1][1], busStopsLocs[busCheckpoint+1][2], busStopsLocs[busCheckpoint+1][3]-1.0, 0, 0, 0, 0, 0, 0, 2.0, 2.0, 200.0, 9, 164, 0, 180, 0, 0, 0, 0)
						else
							DrawMarker(1, busStopsLocs[busCheckpoint+1][1], busStopsLocs[busCheckpoint+1][2], busStopsLocs[busCheckpoint+1][3]-1.0, 0, 0, 0, 0, 0, 0, 2.0, 2.0, 200.0, 9, 164, 0, 180, 0, 0, 0, 0)
						end
					end
					if(busStopsLocs[busCheckpoint][4] == true)then
						DrawMarker(1, busStopsLocs[busCheckpoint][1], busStopsLocs[busCheckpoint][2], busStopsLocs[busCheckpoint][3]-1.0, 0, 0, 0, 0, 0, 0, 5.0, 5.0, 200.0, 9, 164, 0, 180, 0, 0, 0, 0)
						if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, busStopsLocs[busCheckpoint][1], busStopsLocs[busCheckpoint][2], busStopsLocs[busCheckpoint][3], true) < 8.0)then
							if(atBusStop == false)then
								vRPCbus.stopAtBusStop(true)
							end
						else
							atBusStop = false
						end
					else
						DrawMarker(1, busStopsLocs[busCheckpoint][1], busStopsLocs[busCheckpoint][2], busStopsLocs[busCheckpoint][3]-1.0, 0, 0, 0, 0, 0, 0, 5.0, 5.0, 200.0, 9, 164, 0, 180, 0, 0, 0, 0)
						if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, busStopsLocs[busCheckpoint][1], busStopsLocs[busCheckpoint][2], busStopsLocs[busCheckpoint][3], true) < 8.0)then
							vRPCbus.stopAtBusStop(false)
						end
					end
				end
				if(busCheckpoint == #busStopsLocs)then
					if(finishBlip == nil)then
						finishBlip = AddBlipForCoord(finishBusRoute[1], finishBusRoute[2], finishBusRoute[3])
						SetBlipSprite(finishBlip, 270)
						SetBlipColour(finishBlip, 1)
						SetBlipAsShortRange(finishBlip, false)
					end
					drawtotal(finishBusRoute[1], finishBusRoute[2], finishBusRoute[3] -1.950, "~w~Apasa ~y~E~w~ pentru a termina ~y~munca", 4, 0.1, 0.1)
					if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, finishBusRoute[1], finishBusRoute[2], finishBusRoute[3], true) < 5.0)then
						if(IsControlJustReleased(1, 51))then
							vRPCbus.finishBusRoute(busCheckpoint)
						end
					end
				end
				if(DoesBlipExist(busBlip))then
					RemoveBlip(busBlip)
					busBlip = nil
				end
			else
				drawText("~y~Urca-te inapoi in autobuz pentru a continua traseul.", 0.5, 0.9, 0.4, 255, 255, 255)
				if(busBlip == nil)then
					busBlip = AddBlipForEntity(theBus)
					SetBlipSprite(busBlip, 513)
					SetBlipColour(busBlip, 1)
					SetBlipAsShortRange(busBlip, false)
				end
			end
		else
			if(hasBusRouteStarted)then
				vRPCbus.stopBusRoute()
			end
			if(busSpawnLocs ~= nil)then
				for i, v in pairs(busSpawnLocs) do
					if(theBlips[i] == nil)then
						theBlips[i] = AddBlipForCoord(v[1], v[2], v[3])
						SetBlipSprite(theBlips[i], 513)
						SetBlipColour(theBlips[i], 1)
						AddTextComponentString("Job Autobuz")
						SetBlipScale(theBlips[i],0.7)
						SetBlipAsShortRange(theBlips[i], true)
					end
					if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, v[1], v[2], v[3], true) <= 10.0)then
						drawtotal(v[1], v[2], v[3] -1.950, "~w~Apasa ~b~E~w~ pentru a spawna un ~b~Autobuz", 4, 0.1, 0.1)
						if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, v[1], v[2], v[3], true) < 2.0)then
							if(IsControlJustReleased(1, 51))then
								vRPSbus.spawnTheBus({})
							end
						end
					end
				end
			end
		end
	end
end)
]]

busSpawnLocs = {
	[1] = {457.64465332032,-647.5498046875,28.22996711731}
}

busLoadLocs = {
	{446.13436889648,-674.48352050782,28.468620300292, false},
	{342.05743408204,-685.52685546875,29.345029830932, false},
	{307.59091186524,-766.40692138672,29.257970809936, true},
	{286.68829345704,-844.5482788086,29.11434173584, false},
	{204.87097167968,-824.21417236328,30.877170562744, false},
	{114.69412994384,-785.70880126954,31.359680175782, true},
	{-15.724514007568,-744.02734375,32.423904418946, false},
	{-159.02043151856,-686.77032470704,34.517623901368, false},
	{-244.82369995118,-656.86572265625,33.177612304688, false},
	{-199.5069885254,-514.28936767578,34.767024993896, false},
	{-261.70483398438,-344.6124572754,30.01676940918, false},
	{-378.31338500976,-266.30029296875,34.572612762452, false},
	{-443.54153442382,-238.33311462402,36.076007843018, false},
	{-524.88665771484,-267.91903686524,35.286109924316, true},
	{-614.55944824218,-319.18328857422,34.738998413086, false},
	{-653.60626220704,-290.46691894532,35.504539489746, false},
	{-752.85272216796,-109.84552764892,37.727279663086, false},
	{-594.07232666016,-59.125328063964,42.028797149658, false},
	{-557.3334350586,-29.030445098876,43.419521331788, false},
	{-594.03601074218,5.3750019073486,43.470542907714, false},
	{-694.6566772461,-7.7694001197814,38.147178649902, true},
	{-797.50360107422,-62.56103515625,37.793224334716, false},
	{-927.20086669922,-124.59349822998,37.621971130372, true},
	{-1008.8112792968,-172.57611083984,37.827739715576, false},
	{-1230.4438476562,-297.18911743164,37.626804351806, false},
	{-1414.898803711,-405.57977294922,36.366512298584, false},
	{-1480.8586425782,-440.27954101562,35.47248840332, false},
	{-1525.5915527344,-468.18435668946,35.383449554444, true},
	{-1635.6463623046,-559.7417602539,33.581111907958, false},
	{-1625.2685546875,-607.14526367188,32.790340423584, false},
	{-1535.3330078125,-667.2666015625,28.90389251709, false},
	{-1477.7371826172,-632.10815429688,30.517822265625, true},
	{-1396.6945800782,-575.48388671875,30.293865203858, false},
	{-1316.8299560546,-527.01574707032,32.784450531006, false},
	{-1274.0516357422,-544.23010253906,31.03455734253, false},
	{-1188.9395751954,-643.7890625,23.33450126648, false},
	{-1052.6206054688,-794.13275146484,18.98310661316, false},
	{-862.78289794922,-950.44616699218,15.757440567016, false},
	{-782.6401977539,-1095.8739013672,10.718092918396, false},
	{-668.88861083984,-1275.870727539,10.671800613404, false},
	{-602.0908203125,-1260.0417480468,11.672262191772, false},
	{-533.25903320312,-1110.4447021484,22.109872817994, false},
	{-469.18661499024,-1104.9639892578,27.547304153442, false},
	{-312.52252197266,-1141.2166748046,24.08289527893, false},
	{-167.8152923584,-1149.847290039,23.27227973938, true},
	{74.364372253418,-1107.5648193359,29.28271484375, false},
	{131.50291442871,-1021.9359130859,29.252521514893, true},
	{206.88217163086,-1152.6271972656,29.350481033326, false},
	{214.75367736816,-1266.9360351562,29.345527648926, false},
	{170.48680114746,-1373.0111083984,29.335916519166, false},
	{254.81205749512,-1474.5354003906,29.210702896118, true},
	{353.68438720704,-1548.573852539,29.29658317566, false},
	{439.49102783204,-1616.6165771484,29.334770202636, false},
	{542.03533935546,-1556.153930664,29.211254119874, false},
	{538.14422607422,-1376.9829101562,29.270030975342, false},
	{503.6625366211,-1150.984375,29.293075561524, false},
	{487.23776245118,-822.33447265625,25.109920501708, false},
	{409.9761352539,-787.90399169922,29.214849472046, true},
	{408.7497253418,-696.28021240234,29.233535766602, false}
}

finishBusPoint = {463.5178527832,-628.7348022461,28.47465133667}

busDrivers = {}

function vRPSbus.executeBusDriverJob(thePlayer)
	vRPCbus.busPopulateData(thePlayer, {busSpawnLocs, busLoadLocs, finishBusPoint})
end

function vRPSbus.spawnTheBus()
	local thePlayer = source
	local user_id = vRP.getUserId({thePlayer})
	if(busDrivers[user_id] == nil)then
		busDrivers[user_id] = 0
		vRPCbus.spawnTheBus(thePlayer, {})
	else
		vRPclient.notify(thePlayer, {"Eroare: Ai deja un autobuz spawnat",2500,2})
	end
end

function vRPSbus.stopBusRoute()
	local thePlayer = source
	local user_id = vRP.getUserId({thePlayer})
	if(busDrivers[user_id] ~= nil)then
		busDrivers[user_id] = nil
	end
end

function vRPSbus.oferaCash()
	local thePlayer = source
	local user_id = vRP.getUserId({thePlayer})
	local thePay = math.random(1500,2000)
	vRP.giveMoney({user_id, thePay})
	vRPclient.notify(thePlayer, {"Succes: Ai primit "..thePay.."$ de la aceasta misiune",2500,1})
end

function vRPSbus.payBusDriverZA(routesDone)
	local thePlayer = source
	local user_id = vRP.getUserId({thePlayer})
	local rewardMoney = 5000
	vRP.giveMoney({user_id, rewardMoney})
	vRPclient.notify(thePlayer, {"Succes: Ai primit "..rewardMoney.."$ pentru tura de Sofer Autobuz",2500,1})
	busDrivers[user_id] = nil
end

AddEventHandler("vRP:playerSpawn",function(user_id,source,first_spawn)
	if first_spawn then
		vRPCbus.maidaticudumpul(source, {loadautobuz})
		vRPSbus.executeBusDriverJob(source)
	end
end)

AddEventHandler("vRP:playerLeave",function(user_id, source)
	busDrivers[user_id] = nil
	vRPCbus.deleteTrashTruck(source, {})
end)